<?xml version="1.0" encoding="UTF-8"?>
<!--
Crane-gcExportSubset-obfuscated.xsl

This is a stylesheet to export an OpenOffice spreadsheet to OASIS genericode
making assumptions regarding the worksheet tab name and the column names.

Copyright (C) - Crane Softwrights Ltd. 
              - http://www.CraneSoftwrights.com/links/res-dev.htm

The specification for OASIS genericode is here:

    http://docs.oasis-open.org/codelist/genericode

RESTRICTIONS:

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
- The name of the author may not be used to endorse or promote products
  derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Note: for your reference, the above is the "Modified BSD license", this text
      was obtained 2003-07-26 at http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5

THE AUTHOR MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS CODE FOR ANY
PURPOSE.

TECHNICAL NOTE:

This stylesheet has been purposely obfuscated and all comments have been
removed.

  
gcExportSubset.xsl $Id: gcExportSubset.xsl,v 1.4 2011/10/30 02:00:21 admin Exp $
odsCommon.xsl $Id: odsCommon.xsl,v 1.15 2009/02/07 22:31:16 gkholman Exp $
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:o="urn:X-Crane:stylesheets:odf-access" xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" xmlns:xs="http://www.CraneSoftwrights.com/ns/xslstyle" xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0" xmlns:gc="http://docs.oasis-open.org/codelist/ns/genericode/1.0/" xmlns:c="urn:X-Crane:stylesheets:gc-toolkit" exclude-result-prefixes="xs xsd gc c o office table" version="2.0"><xsl:param name="worksheetIdentifier" as="xsd:string" select="'ModelName'"/><xsl:output indent="yes"/><xsl:template match="/"><xsl:choose><xsl:when test="not(office:document)"><xsl:apply-templates mode="c:I1189764485" select="$o:I1189764485/node()"><xsl:with-param name="c:O594882242" tunnel="yes" as="text()*"><xsl:text>This filter does not support an instance </xsl:text><xsl:value-of select="concat('starting with {',namespace-uri(*),'}', name(*))"/></xsl:with-param></xsl:apply-templates></xsl:when><xsl:otherwise><xsl:call-template name="c:I396588161"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="c:I396588161"><xsl:for-each select="/office:document/office:body/office:spreadsheet/ table:table"><xsl:variable name="c:I297441121" select="@table:name"/><xsl:variable name="c:I237952897" as="element()*"><xsl:for-each select="table:table-row[1]"><xsl:variable name="c:O198294080" select="."/><xsl:for-each select="1 to xsd:integer( o:O594882242(table:table-cell[last()])[last()] )"><guess><xsl:value-of select="translate(normalize-space( $c:O198294080/table:table-cell[o:O594882242(.)=current()]/o:I396588161(.)), ' ','')"/></guess></xsl:for-each></xsl:for-each></xsl:variable><xsl:variable name="c:I169966355" select="( table:table-row[normalize-space( string-join(table:table-cell/o:I396588161(.),''))='END']/ preceding-sibling::table:table-row[1], table:table-row[last()] )[1]"/><xsl:for-each select="table:table-row[position()&gt;1] [ . is $c:I169966355 or . &lt;&lt; $c:I169966355 ]"><Row><xsl:if test="$worksheetIdentifier"><Value ColumnRef="{$worksheetIdentifier}"><SimpleValue><xsl:value-of select="$c:I297441121"/></SimpleValue></Value></xsl:if><xsl:variable name="c:O198294080" select="."/><xsl:for-each select="1 to xsd:integer( o:O594882242(table:table-cell[last()])[last()] )"><xsl:variable name="c:O148720560" select="."/><xsl:for-each select="$c:O198294080/table:table-cell [o:O594882242(.)=$c:O148720560]/ o:I396588161(.)[normalize-space(.)]"><Value ColumnRef="{$c:I237952897[$c:O148720560]}"><SimpleValue><xsl:value-of select="."/></SimpleValue></Value></xsl:for-each></xsl:for-each></Row></xsl:for-each></xsl:for-each></xsl:template><xsl:variable name="odsTemplate" as="document-node()"><xsl:document><office:document/></xsl:document></xsl:variable><xsl:variable xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I1189764485" select="if( /office:document ) then (/) else $odsTemplate" as="document-node()"/><xsl:variable xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I297441121" as="element(table:table)*" select="$o:I1189764485/office:document/office:body/office:spreadsheet/table:table"/><xsl:key xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I237952897" match="style:style" use="@style:name"/><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I169966355" as="xsd:string"><xsl:param name="o:O198294080" as="attribute()*"/><xsl:sequence select="if( not( $o:O198294080 ) ) then '' else if( starts-with($o:O198294080,'Crane') ) then $o:O198294080 else o:I169966355(key('o:I237952897',$o:O198294080,root($o:O198294080))/ @style:parent-style-name)"/></xsl:function><xsl:key xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O148720560" match="table:table-cell[ o:I169966355(preceding-sibling::table:table-cell[2]/@table:style-name)]" use="substring-after( o:I169966355(preceding-sibling::table:table-cell[2]/@table:style-name), 'CraneLabel')"/><xsl:key xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I132196053" match="table:table-cell[ o:I169966355(preceding-sibling::table:table-cell[2]/@table:style-name)]" use="1"/><xsl:key xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O118976448" match="table:table-cell[o:I169966355(@table:style-name)]" use="o:I169966355(@table:style-name)"/><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O99147040" as="node()?"><xsl:param name="o:I108160407" as="xsd:string"/><xsl:sequence select="o:O99147040($o:I108160407,$o:I1189764485)"/></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O99147040" as="node()?"><xsl:param name="o:I108160407" as="xsd:string"/><xsl:param name="o:I91520345" as="node()"/><xsl:sequence select="key('o:O148720560',$o:I108160407,$o:I91520345)"/></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I396588161" as="xsd:string?"><xsl:param name="o:I84983177" as="element(table:table-cell)?"/><xsl:sequence select="string-join($o:I84983177/text:p/string(.),' ')"/></xsl:function><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O79317632"><xsl:analyze-string select="." regex=".+"><xsl:matching-substring><text:p><xsl:value-of select="."/></text:p></xsl:matching-substring></xsl:analyze-string></xsl:template><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I62619183"><xsl:param name="o:O74360280" as="document-node()" required="yes"/><xsl:param name="o:O69986146" tunnel="yes" as="xsd:boolean" select="false()"/><xsl:param name="o:O66098026" tunnel="yes" as="xsd:boolean" select="false()"/><xsl:copy><xsl:if test="not($o:O69986146)"><xsl:apply-templates select="@*"/></xsl:if><xsl:choose><xsl:when test="$o:O74360280"><xsl:variable name="o:O59488224" as="document-node()"><xsl:document><xsl:apply-templates select="$o:O74360280/node()" mode="o:I62619183"/></xsl:document></xsl:variable><xsl:for-each select="$o:O59488224"><xsl:call-template name="o:O79317632"/></xsl:for-each></xsl:when><xsl:when test="$o:O66098026"/><xsl:otherwise><xsl:apply-templates/></xsl:otherwise></xsl:choose></xsl:copy></xsl:template><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" mode="o:I62619183" match="*"><xsl:param name="o:I56655451" tunnel="yes" as="xsd:string*" select="()"/><xsl:text/>&lt;<xsl:value-of select="name(.)"/><xsl:for-each select="namespace::*[not(.= (../namespace::xml,$o:I56655451))]"><xsl:if test="not(name(.)=../../namespace::*/name(.))"><xsl:value-of select="concat(' xmlns',if(name()) then ':' else '', name(.),'=&#34;',.,'&#34;')"/></xsl:if></xsl:for-each><xsl:for-each select="@*"><xsl:choose><xsl:when test="contains(.,'&#34;')"><xsl:value-of select="concat(&#34; &#34;,name(.),&#34;='&#34;,.,&#34;'&#34;)"/></xsl:when><xsl:otherwise><xsl:value-of select="concat(' ',name(.),'=&#34;',.,'&#34;')"/></xsl:otherwise></xsl:choose></xsl:for-each><xsl:choose><xsl:when test="node()"><xsl:text>&gt;</xsl:text><xsl:apply-templates mode="o:I62619183" select="node()"/><xsl:text/>&lt;/<xsl:value-of select="name(.)"/>&gt;<xsl:text/></xsl:when><xsl:otherwise><xsl:text>/&gt;</xsl:text></xsl:otherwise></xsl:choose></xsl:template><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" mode="o:I62619183" match="text()"><xsl:value-of select="."/></xsl:template><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" mode="o:I62619183" match="comment()"><xsl:value-of select="concat('&lt;!--',.,'--&gt;')"/></xsl:template><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" mode="o:I62619183" match="processing-instruction()"><xsl:value-of select="concat('&lt;?',name(.),' ',.,'?&gt;')"/></xsl:template><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" match="@*|node()" mode="#default o:I54080203"><xsl:copy><xsl:apply-templates select="@*,node()" mode="#default"/></xsl:copy></xsl:template><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O49573520" as="xsd:anyAtomicType*"><xsl:param name="o:O51728890" as="xsd:anyAtomicType*"/><xsl:perform-sort select="$o:O51728890"><xsl:sort/></xsl:perform-sort></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O45760172" as="node()*"><xsl:param name="o:I47590579" as="node()*"/><xsl:perform-sort select="$o:I47590579"><xsl:sort/></xsl:perform-sort></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O594882242" as="xsd:double+"><xsl:param name="o:I84983177" as="node()"/><xsl:for-each select="$o:I84983177[self::table:table-cell]"><xsl:variable name="start" select="count(preceding-sibling::table:table-cell) + 1 + sum(preceding-sibling::table:table-cell/@table:number-columns-spanned) + sum(preceding-sibling::table:table-cell/@table:number-columns-repeated) - count(preceding-sibling::table:table-cell[@table:number-columns-spanned]) - count(preceding-sibling::table:table-cell[@table:number-columns-repeated])"/><xsl:sequence select="xsd:integer($start) to xsd:integer( $start - 1 + ( if( @table:number-columns-repeated ) then @table:number-columns-repeated else 1 ) )"/></xsl:for-each><xsl:for-each select="$o:I84983177[self::table:table-column]"><xsl:variable name="start" select="count(preceding-sibling::table:table-column) + 1 + sum(preceding-sibling::table:table-column/@table:number-columns-repeated) - count(preceding-sibling::table:table-column[@table:number-columns-repeated])"/><xsl:sequence select="xsd:integer($start) to xsd:integer( $start - 1 + ( if( @table:number-columns-repeated ) then @table:number-columns-repeated else 1 ) )"/></xsl:for-each></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I44065351" as="xsd:double+"><xsl:param name="o:I44065351" as="element(table:table-row)"/><xsl:for-each select="$o:I44065351"><xsl:variable name="start" select="count(preceding-sibling::table:table-row) + 1 + sum(preceding-sibling::table:table-row/@table:number-rows-repeated) - count(preceding-sibling::table:table-row[@table:number-rows-repeated])"/><xsl:sequence select="xsd:integer($start) to xsd:integer( $start - 1 + ( if( @table:number-rows-repeated ) then @table:number-rows-repeated else 1 ) )"/></xsl:for-each></xsl:function><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O42491588" mode="o:O42491588" match="table:table-cell"><xsl:param name="o:O74360280" as="node()?" required="yes"/><xsl:param name="o:O69986146" tunnel="yes" as="xsd:boolean" select="false()"/><xsl:param name="o:O66098026" tunnel="yes" as="xsd:boolean" select="false()"/><xsl:copy><xsl:if test="not($o:O69986146)"><xsl:apply-templates select="@*"/></xsl:if><xsl:choose><xsl:when test="string($o:O74360280)"><xsl:if test="not($o:O66098026)"><xsl:apply-templates select="* except text:*"/></xsl:if><xsl:for-each select="$o:O74360280"><xsl:call-template name="o:O79317632"/></xsl:for-each></xsl:when><xsl:when test="$o:O66098026"/><xsl:otherwise><xsl:apply-templates/></xsl:otherwise></xsl:choose></xsl:copy></xsl:template><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O39658816" as="xsd:integer"><xsl:param name="o:I41026361" as="xsd:string"/><xsl:analyze-string select="$o:I41026361" regex="\s*(([A-Z])?([A-Z]))?([A-Z])\s*"><xsl:matching-substring><xsl:sequence select="o:I38379499(regex-group(2))*26*26 + o:I38379499(regex-group(3))*26 + o:I38379499(regex-group(4))"/></xsl:matching-substring></xsl:analyze-string></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I38379499" as="xsd:integer"><xsl:param name="o:I41026361" as="xsd:string"/><xsl:sequence select="if($o:I41026361='') then 0 else string-to-codepoints($o:I41026361) - string-to-codepoints('A') + 1"/></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I36053469" as="xsd:string"><xsl:param name="o:O37180140" as="xsd:integer"/><xsl:variable name="o:I34993073" select="( $o:O37180140 - 1 ) idiv (27*26)"/><xsl:variable name="o:I33993271" select="(($o:O37180140 - 1 + $o:I34993073*26) mod (27*26) idiv 26)"/><xsl:variable name="o:I33049013" select="( $o:O37180140 - 1 ) mod 26 + 1"/><xsl:sequence select="concat( o:O32155796( $o:I34993073 ), o:O32155796( $o:I33993271 ), o:O32155796( $o:I33049013 ) )"/></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:O32155796" as="xsd:string"><xsl:param name="o:I31309591" as="xsd:integer"/><xsl:sequence select="if($o:I31309591=0) then '' else codepoints-to-string( $o:I31309591 + string-to-codepoints('A') - 1 )"/></xsl:function><xsl:template xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I30506781"><xsl:for-each select="1 to 1024"><xsl:variable name="o:O29744112" select="."/><xsl:variable name="o:I41026361" select="o:I36053469($o:O29744112)"/><xsl:variable name="o:I29018645" select="o:O39658816($o:I41026361)"/><xsl:message select="concat( $o:O29744112,'=',$o:I41026361,'=',$o:I29018645 )"/><xsl:if test="$o:O29744112 != $o:I29018645"><xsl:message terminate="yes" select="'o:I28327725'"/></xsl:if></xsl:for-each></xsl:template><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I25864445" as="text()*"><xsl:param name="o:I27668941" as="xsd:anyAtomicType?"/><xsl:param name="o:I27040101" as="xsd:integer"/><xsl:param name="o:O26439210" as="xsd:integer"/><xsl:analyze-string select="$o:I27668941" regex="(\$?)([A-Z])+(\$?)(\d+)"><xsl:matching-substring><xsl:value-of select="concat(regex-group(1), o:I36053469(o:O39658816(regex-group(2)) + $o:I27040101), regex-group(3), xsd:integer(regex-group(4)) + $o:O26439210 )"/></xsl:matching-substring><xsl:non-matching-substring><xsl:value-of select="."/></xsl:non-matching-substring></xsl:analyze-string></xsl:function><xsl:function xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" name="o:I25314137" as="xsd:string"><xsl:param name="o:I84983177" as="element(table:table-cell)"/><xsl:for-each select="$o:I84983177"><xsl:sequence select="concat(ancestor::table:table[1]/@table:name,'.', o:I36053469(xsd:integer(o:O594882242(.))), o:I44065351(..))"/></xsl:for-each></xsl:function></xsl:stylesheet>